[PATCH 2/2] scripts/decodecode: Add support for RISC-V

Björn Töpel bjorn at kernel.org
Fri Jan 13 06:45:52 PST 2023


From: Björn Töpel <bjorn at rivosinc.com>

RISC-V has some GNU disassembly quirks, e.g. it requires '-D' to
properly disassemble .byte directives similar to Arm [1]. Further, GNU
objdump groups RISC-V instruction by 2 or 4 byte chunks, instead doing
byte-for-byte.

Add the required switches, and translate from short/word to bytes when
ARCH is "riscv".

An example how to invoke decodecode for RISC-V:
  $ echo 'Code: 64 c9 29 a0 17 d4 1f 01 13 04 44
  b8 93 92 38 00 16 94 00 60 <02> 94 aa e8' |  \
  AFLAGS="-march=rv64imac_zicbom_zihintpause"  \
  ARCH=riscv CROSS_COMPILE=riscv64-linux-gnu- ./scripts/decodecode
  Code: 64 c9 29 a0 17 d4 1f 01 13 04 44 b8 93 92 38 00 16 94 00 60 <02> 94 aa e8
  All code
  ========
     0:   c964                    c.sw    s1,84(a0)
     2:   a029                    c.j     c <.text+0xc>
     4:   011fd417                auipc   s0,0x11fd
     8:   b8440413                addi    s0,s0,-1148 # 11fcb88 <.text+0x11fcb88>
     c:   00389293                slli    t0,a7,0x3
    10:   9416                    c.add   s0,t0
    12:   6000                    c.ld    s0,0(s0)
    14:*  9402                    c.jalr  s0              <-- trapping instruction
    16:   e8aa                    c.sdsp  a0,80(sp)

  Code starting with the faulting instruction
  ===========================================
     0:   9402                    c.jalr  s0
     2:   e8aa                    c.sdsp  a0,80(sp)

[1] https://sourceware.org/bugzilla/show_bug.cgi?id=10263

Signed-off-by: Björn Töpel <bjorn at rivosinc.com>
---
 scripts/decodecode | 12 +++++++++++-
 1 file changed, 11 insertions(+), 1 deletion(-)

diff --git a/scripts/decodecode b/scripts/decodecode
index b28fd2686561..8fe71c292381 100755
--- a/scripts/decodecode
+++ b/scripts/decodecode
@@ -93,6 +93,11 @@ disas() {
 		${CROSS_COMPILE}strip $t.o
 	fi
 
+	if [ "$ARCH" = "riscv" ]; then
+		OBJDUMPFLAGS="-M no-aliases --section=.text -D"
+		${CROSS_COMPILE}strip $t.o
+	fi
+
 	if [ $pc_sub -ne 0 ]; then
 		if [ $PC ]; then
 			adj_vma=$(( $PC - $pc_sub ))
@@ -126,8 +131,13 @@ get_substr_opcode_bytes_num()
 	do
 		substr+="$opc"
 
+		opcode="$substr"
+		if [ "$ARCH" = "riscv" ]; then
+			opcode=$(echo $opcode | tr ' ' '\n' | tac | tr -d '\n')
+		fi
+
 		# return if opcode bytes do not match @opline anymore
-		if ! echo $opline | grep -q "$substr";
+		if ! echo $opline | grep -q "$opcode";
 		then
 			break
 		fi
-- 
2.37.2




More information about the linux-riscv mailing list